%MACRO read_ssd_unix(dsn=, suffix=ssd, lib=convert, debug=N);
  %LET header_len = 218;  /*unix*/

  DATA &dsn._hdr;
    INFILE "&dsn..&suffix." RECFM = F LRECL = &header_len. TRUNCOVER;
    IF _N_ = 1 THEN DO;
      INPUT @1 sys $CHAR8.
            @9 version $CHAR8.
            @17 opsys $CHAR8.
            @25 platform $CHAR8.
            @41 libname $CHAR8.
            @49 memname $CHAR8.
            @57 memtype $CHAR8.
            @126 nvar PIB1.  /*unix*/
            ;
      OUTPUT;
      FILE tmpfiles(&dsn._code.txt);
      PUT "DATA &lib.." memname ';';
      FILE tmpfiles(&dsn._input.txt);
      PUT '    INPUT';
      FILE tmpfiles(&dsn._convert.txt);
      PUT '    * convert numeric vars *;';
      CALL SYMPUT('nvar', nvar);
    END;
    ELSE DO;
      INPUT;
      FILE tmpfiles(&dsn._rest.dat) RECFM = F LRECL = &header_len.;
      PUT _INFILE_;
    END;
  RUN;

  %LET col_len = 106;

  DATA &dsn._cols;
    INFILE tmpfiles(&dsn._rest.dat) RECFM = F LRECL = &col_len.
           TRUNCOVER;
    RETAIN record_len 4;
    IF _N_ LE &nvar. THEN DO;  /*unix*/
      INPUT @2 type PIB1.  /*unix*/
            @6 length PIB1.  /*unix*/ 
            @8 num PIB1.  /*unix*/ 
            @9 name $8.
            @17 label $CHAR48.
            ;
      OUTPUT;
      FILE tmpfiles(&dsn._attrib.txt);
      IF type = 2 THEN PUT '    ATTRIB ' name 'LENGTH=$' length
           'LABEL="' label +(-1) '";';
      ELSE PUT '    ATTRIB ' name 'LABEL="' label +(-1) '";';
      FILE tmpfiles(&dsn._input.txt) MOD;
      record_len1 = record_len + 1;
      record_len + length;
      IF type = 2 THEN PUT '        ' name '$ ' record_len1 +(-1) '-'
           record_len;
      ELSE DO;
        PUT '        ____' name '$ ' record_len1 +(-1) '-'
          record_len;
        FILE tmpfiles(&dsn._convert.txt) MOD;
        PUT '    ' name ' = INPUT(____' name +(-1) ', IEEE' length +
          (-1) '.);';  /*unix*/
        PUT '    DROP ____' name +(-1) ';';
      END;
      IF _N_ = &nvar. THEN DO;  /*unix*/
        CALL SYMPUT('rec_len', record_len);
        FILE tmpfiles(&dsn._attrib.txt);
        PUT "    INFILE tmpfiles(&dsn._data.dat) RECFM = F LRECL = "
          record_len ' TRUNCOVER;';
        FILE tmpfiles(&dsn._input.txt) MOD;
        PUT '    ;';
       END;
     END;
     ELSE DO;
      INPUT;
      FILE tmpfiles(&dsn._data.dat) RECFM = F LRECL = &col_len.;
      PUT _INFILE_;
  %if %upcase(&debug.) EQ Y %then %do;
      _ERROR_ = 1;
  %end;
    END;
  RUN;

  %INCLUDE tmpfiles(&dsn._code.txt) / SOURCE2;
  %INCLUDE tmpfiles(&dsn._attrib.txt) / SOURCE2;
  %INCLUDE tmpfiles(&dsn._input.txt) / SOURCE2;
  %INCLUDE tmpfiles(&dsn._convert.txt) / SOURCE2;
    IF _INFILE_ NE ' ' THEN OUTPUT;
  %if %upcase(&debug.) EQ Y %then %do;
    _ERROR_ = 1;
  %end;
  RUN;
%MEND read_ssd_unix;
