/* set the graphics environment */
goptions reset = global gunit = pct border
         hsize = 18 cm vsize = 12 cm
         device = png;

   /* execute a DATA step with DSGI */
data heart;
      /* initialize SAS/GRAPH software */
      /* to accept DSGI statements     */
   rc=ginit();
   rc=graph("clear");

      /* assign colors to color index */
   rc=gset("colrep", 1, "blue");
   rc=gset("colrep", 2, "red");

      /* define and display titles */
   rc=gset("texcolor", 1);
   rc=gset("texfont", "swissb");
   rc=gset("texheight", 6);
   rc=gdraw("text", 90, 83, "Heart");

      /* change the height and */
      /* display second title  */
   rc=gset("texheight", 4);
   rc=gdraw("text", 90, 75, "Created with DSGI");

      /* change the height and */
      /* display footnote  */
   rc=gset("texheight", 4);
   rc=gdraw("text", 130, 15, "SAS");

      /* define and draw heart */
   rc=gset("lincolor", 2);
   rc=gset("linwidth", 1);

   pi = constant('pi');
   centerx = 110;
   centery = 40;
   scalex = 30 / 16;
   scaley = 30 / 18;
   do t = 0 to 2 * pi by 0.01;
      x = centerx + scalex * (16 * sin(t) ** 3);
      y = centery + scaley * (13 * cos(t) - 5 * cos(2 * t) - 2 * cos(3 * t) - cos(4 * t));
      if t > 0 then rc = gdraw("line", 2, x0, x, y0, y);
      output;
      x0 = x;
      y0 = y;
   end;

      /* display graph and end DSGI */
   rc=graph("update");
   rc=gterm();
run;
